using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TheLandBeforeDataBinding
{
    public partial class IDEDataBindingsForm : Form
    {
        List<RaceCarDriverDefault> drivers = new List<RaceCarDriverDefault>();

        public IDEDataBindingsForm()
        {
            InitializeComponent();

            drivers.Add(new RaceCarDriverDefault("M Schumacher", 500));
            
            bindingSourceDriver.DataSource = drivers;

            bindingSourceDriver.Add(new RaceCarDriverDefault("A Senna", 1000));
            bindingSourceDriver.Add(new RaceCarDriverDefault("A Prost", 400));

            RefreshItems();
        }

        private void IDEDataBindingsForm_Load(object sender, EventArgs e)
        {
            
        }

        void RefreshItems()
        {
            int count = this.bindingSourceDriver.Count;
            int pos = this.bindingSourceDriver.Position + 1;

            this.labelCount.Text = count.ToString();
            this.labelPosition.Text = pos.ToString();

            this.buttonFirst.Enabled = (pos > 1);
            this.buttonPrev.Enabled = (pos > 1);
            this.buttonNext.Enabled = (pos < count);
            this.buttonLast.Enabled = (pos < count);
        }

        private void buttonFirst_Click(object sender, EventArgs e)
        {
            bindingSourceDriver.MoveFirst();
            RefreshItems();
        }

        private void buttonPrev_Click(object sender, EventArgs e)
        {
            bindingSourceDriver.MovePrevious();
            RefreshItems();
        }

        private void buttonNext_Click(object sender, EventArgs e)
        {
            bindingSourceDriver.MoveNext();
            RefreshItems();
        }

        private void buttonLast_Click(object sender, EventArgs e)
        {
            bindingSourceDriver.MoveLast();
            RefreshItems();
        }

        private void buttonAddWin_Click(object sender, EventArgs e)
        {
            int current = this.bindingSourceDriver.Position;
            drivers[current].Wins++;
        }

        private void buttonShowData_Click(object sender, EventArgs e)
        {
            MessageBox.Show(bindingSourceDriver[this.bindingSourceDriver.Position].ToString());
        }
    }
}