using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace TheLandBeforeDataBinding
{
    class RaceCarDriverNotify : INotifyPropertyChanged
    {
        String name;
        int wins;

        public RaceCarDriverNotify(String name, int wins)
        {
            this.name = name;
            this.wins = wins;
        }

        public String Name
        {
            get { return this.name; }
            set
            {
                this.name = value;
                this.OnPropertyChanged("Name");
            }
        }

        public int Wins
        {
            get { return this.wins; }
            set
            {
                this.wins = value;
                this.OnPropertyChanged("Wins");
            }
        }

        public override string ToString()
        {
            return Name + ", " + Wins.ToString(); ;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        void OnPropertyChanged(String propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(
                    this,
                    new PropertyChangedEventArgs(propertyName)
                );
            }
        }

        #endregion
    }
}
