using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TheLandBeforeDataBinding
{
    public partial class TheLandBeforeDataBindingForm : Form
    {
        RaceCarDriver driver = new RaceCarDriver("M Schumacher", 500);
        RaceCarDriverNotify driverNotify = new RaceCarDriverNotify("", 0);

        public TheLandBeforeDataBindingForm()
        {
            InitializeComponent();

            this.textBoxName.Text = this.driver.Name;
            this.textBoxWins.Text = this.driver.Wins.ToString();

            driverNotify.PropertyChanged += new PropertyChangedEventHandler(driverNotify_PropertyChanged);
            driverNotify.Name = "M Schumacher";
            driverNotify.Wins = 500;
            
        }

        void driverNotify_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            switch (e.PropertyName)
            {
                case "Name":
                    this.textBoxNameNotify.Text = this.driverNotify.Name;
                    break;
                case "Wins":
                    this.textBoxWinsNotify.Text = this.driverNotify.Wins.ToString();
                    break;
            }
        }

        private void labelName_Click(object sender, EventArgs e)
        {
            
        }

        private void buttonAddWin_Click(object sender, EventArgs e)
        {
            driver.Wins++;
            textBoxWins.Text = driver.Wins.ToString();
        }

        private void buttonShowData_Click(object sender, EventArgs e)
        {
            MessageBox.Show(driver.ToString());
        }

        private void textBoxName_TextChanged(object sender, EventArgs e)
        {
            driver.Name = textBoxName.Text;
        }

        private void textBoxWins_TextChanged(object sender, EventArgs e)
        {
            driver.Wins = int.Parse(textBoxWins.Text);
        }

        private void textBoxNameNotify_TextChanged(object sender, EventArgs e)
        {
            driverNotify.Name = textBoxNameNotify.Text;
        }

        private void textBoxWinsNotify_TextChanged(object sender, EventArgs e)
        {
            driverNotify.Wins = int.Parse(textBoxWinsNotify.Text);
        }

        private void buttonAddWinNotify_Click(object sender, EventArgs e)
        {
            driverNotify.Wins++;
        }

        private void buttonShowDataNotify_Click(object sender, EventArgs e)
        {
            MessageBox.Show(driverNotify.ToString());
        }

        private void buttonBinding_Click(object sender, EventArgs e)
        {
            new SimpleDataBindingAndItemDataSources().ShowDialog();
        }

        private void buttonBindingList_Click(object sender, EventArgs e)
        {
            new SimpleDataBindingAndListDataSourcesForm().ShowDialog();
        }

        private void buttonListComplex_Click(object sender, EventArgs e)
        {
            new ComplexBindingListBoxForm().ShowDialog();
        }

        private void buttonGrid_Click(object sender, EventArgs e)
        {
            new ComplexBindingDataGridForm().ShowDialog();
        }

        private void TheLandBeforeDataBindingForm_Load(object sender, EventArgs e)
        {

        }

        private void buttonBindingListT_Click(object sender, EventArgs e)
        {
            new ComplexBindingDataGridBinding().ShowDialog();
        }

        private void buttonBindingDefault_Click(object sender, EventArgs e)
        {
            new ComplexBindingDataGridDefault().ShowDialog();
        }

        private void buttonBindingSource_Click(object sender, EventArgs e)
        {
            new BindingSourceForm().ShowDialog();
        }

        private void buttonSourceSimple_Click(object sender, EventArgs e)
        {
            new IDEDataBindingsForm().ShowDialog();
        }
    }
}